package u8c.bs.mytest.bp;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.pub.BusinessException;
import u8c.pubitf.rule.IRule;
import u8c.vo.AggDemandVO;
import u8c.vo.DemandBVO;
import u8c.vo.DemandVO;

public class ValidateRule implements IRule<AggDemandVO> {

	private  IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	/**
	 * У
	 */
	@Override
	public void process(AggDemandVO[] vos) throws BusinessException {
		for(int i = 0; i < vos.length; i++) {
			DemandVO demandVO = (DemandVO) vos[i].getParentVO();
			getVbillcode(demandVO.getVbillcode());
			DemandBVO[] demandBVOs = (DemandBVO[]) vos[i].getChildrenVO();
			for (int j = 0; j < demandBVOs.length; j++) {
				getJobbasfil(demandBVOs[j].getPrjcode(), demandBVOs[j].getPrjname());
				getJobtype(demandBVOs[j].getPrjtypecode(), demandBVOs[j].getPrjtypename());
				getInvbasdoc(demandBVOs[j].getCmaterialcode(), demandBVOs[j].getCmaterialname());
			}
		}
		
	}
	
	// ѯݺ
    public  void getVbillcode(String vbillcode) throws BusinessException {
        String sql = "select pk_demand from po_demand where vbillcode ='"+vbillcode+"' and isnull(dr,0) = 0";
        String pk_demand = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_demand != null) {
        	throw new BusinessException("ṩĵݱ벻Ψһϵͳ޷棡");
        }
    }
    
    //ѯĿ
    public void getJobbasfil(String code, String name)throws BusinessException {
    	String sql = "select pk_jobbasfil from bd_jobbasfil where jobcode = '"+code+"' and jobname = '"+name+"' and dr = 0";
    	String pk_jobbasfil = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_jobbasfil == null) {
        	throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1ͣĿ룺"+code+"ƣ"+name+"");
        }
    }
    //ѯ
    public void getJobtype(String code, String name)throws BusinessException {
    	String sql = "select pk_jobtype from bd_jobtype where jobtypecode = '"+code+"' and jobtypename = '"+name+"' and dr = 0";
    	String pk_jobtype = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_jobtype == null) {
        	throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1ͣĿ൵룺"+code+"ƣ"+name+"");
        }
    }
    
    //ѯ
    public void getInvbasdoc(String code, String name)throws BusinessException {
    	String sql = "select pk_invbasdoc from bd_invbasdoc where invcode = '"+code+"' and invname = '"+name+"' and dr = 0";
    	String pk_invbasdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_invbasdoc == null) {
        	throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1ͣϵ룺"+code+"ƣ"+name+"");
        }
    }
    

}
